_DEBUG("Loading strings: Language = " + System.Gadget.Settings.readString("Language"));
var city, state, country, calcmethod, mazhab;
var g_lastEmphasized = -1;
var lastAzanPlayed = -1;
var timeRemaining;
var currentWaitTimeIndex = 0;
var currentProgress = 0;
var currentIndex = 0;
var currentPrayerIndex = 0;
var FajrNextDay = false;
var waitTimes = Array(10*60, 10*60, 10*60, 10*60, 5*60, 3*60, 60, 20, 10);
var prayerNames = Array("FAJR","SUNRISE","DUHR","ASR","MAGHRIB","ISHA");
var periodCheckingHandling = null;
var prayerTimesTimer = null;
var versionCheckTime = null;

var remainingTimeColors = new Array("#00FF00","#00FF00","#00FF00","#00FF00","#00FF00","#00FF00","#33FF00","#66FF00","#99FF00","#CCFF00","#FFFF00","#FFCC00","#FF9900","#FF6600","#FF3300","#FF0000");
var showAlarm = true;
// Stores the prayer times
var g_prayersTime = new Array();
var g_prayersTime24Hrs = new Array();

//var nextPrayerIndex = -1;
var g_PassedIsha = false;

var serverURL = "http://www.loayassaf.com/PrayerTimes/";
//var serverURL = "http://www.techypmp.com/PrayerTimes/";

var xmlHttp = new XMLHttpRequest; //new ActiveXObject("Microsoft.XMLHTTP");
var player = new ActiveXObject("WMPlayer.OCX.7");

System.Gadget.settingsUI = "Settings.htm";


//////////////////////////////////////////////////////////
var toggleTimer;

function startToggling(){
	clearTimeout(toggleTimer);
	var waitTime = 10;
	
	try{
		if(msg.style.display == 'none'){
			if(mainPage.style.display == 'none'){
				mainPage.style.display = '';
				page2.style.display = 'none';
				waitTime = parseInt(waitTimes[currentWaitTimeIndex]);
			}else{
				mainPage.style.display = 'none';
				page2.style.display = '';
				waitTime = 5;
			}
		}
	} catch(ex){
		_DEBUG(ex.description);
		reportError(cleanFuncName(arguments.callee.toString()), ex);
	}
	
	toggleTimer = setTimeout("startToggling()", 1000*waitTime);
}

// Called when the gadget is loaded.
function init(){
	try{
		loadStrings();
				
		var i=0;
		if(System.Gadget.Settings.readString("Mazhab") == ''){
			_DEBUG("initialize the variables");
			//System.Gadget.Settings.writeString("LocationName", geoip_city());
			System.Gadget.Settings.writeString("LocationName", ""); // Make it "" to indicate that it was not selected.
			System.Gadget.Settings.writeString("Latitude", geoip_latitude());
			System.Gadget.Settings.writeString("Longitude", geoip_longitude());

			System.Gadget.Settings.writeString("CalcMethod", "2");
			System.Gadget.Settings.writeString("Mazhab", "0");
			System.Gadget.Settings.writeString("HijriAdjustment", "0");

			System.Gadget.Settings.writeString("AzanOption", "random");		
			System.Gadget.Settings.writeString("AzanFile", serverURL+"getMedia2.php5?file=random");
			System.Gadget.Settings.writeString("FajrAzanFile", serverURL+"getMedia2.php5?file=randomfajr");
			System.Gadget.Settings.writeString("AzanVolume","50");

			for(i=0;i<6;i++){
				if(i!=1){
					System.Gadget.Settings.writeString("Prayer"+i+"_Azan_Enabled", true);
					System.Gadget.Settings.writeString("Prayer"+i+"_Before_Alarm", 15);
					System.Gadget.Settings.writeString("Prayer"+i+"_After_Alarm", 15);
					System.Gadget.Settings.writeString("Prayer"+i+"_Azan_Adjustment", 0);

				}
			}

			System.Gadget.Settings.writeString("Morning_Azkar_Enabled", true);
			System.Gadget.Settings.writeString("Evening_Azkar_Enabled", true);
			System.Gadget.Settings.writeString("AlarmsEnbled", true);
			System.Gadget.Settings.writeString("Use24Hrs", false);
			System.Gadget.Settings.writeString("allowAAPPT", true);
					

			//displayMessage("Thank you for choosing <b>Prayer Times</b>.<br><br>First, click on the wrench icon to configure it.");
			displayMessage(formatStringWithParams(L_WELCOME_MSG, Array(L_PRODUCT_NAME_SHORT)));
			//displayMessage("The <b>Prayer Times</b> gadget thinks that you are in " + geoip_city() + ", " + geoip_region() + " in " + geoip_country_name() + ".<br>First, click on the wrench icon to configure it.");
		} else {
			RefreshPrayerTimes();	// Get the latest prayer times and refresh the display
		}
	} catch(ex){
		_DEBUG("init: " + ex.description);
		reportError(cleanFuncName(arguments.callee.toString()), ex);
	}
}

// Define the "trim" function for Strings
String.prototype.trim = function() { return this.replace(/^\s+|\s+$/g, ""); };

// Calculating the prayer times locally
function RefreshPrayerTimes(){
	_DEBUG("RefreshPrayerTimes");
	var now = new Date();
	
	_DEBUG("CalcMethod=" + System.Gadget.Settings.readString("CalcMethod"));
	_DEBUG("Mazhab=" + System.Gadget.Settings.readString("Mazhab"));

	prayTime.setCalcMethod(1* System.Gadget.Settings.readString("CalcMethod"));
	prayTime.setAsrMethod(1* System.Gadget.Settings.readString("Mazhab"));
	
	if(System.Gadget.Settings.readString("Use24Hrs") == 'True') prayTime.setTimeFormat(prayTime.Time24NS);
	else prayTime.setTimeFormat(prayTime.Time12NS);
	
	lat = 1 * System.Gadget.Settings.readString("Latitude");
	lon = 1 * System.Gadget.Settings.readString("Longitude");
	
	_DEBUG("Lat= " + lat);
	_DEBUG("Lon= " + lon);
	
	_DEBUG("Detected Daylight Saving = " + prayTime.detectDaylightSaving(now));
	_DEBUG("Detected Time Zone = " + prayTime.getTimeZone(now));
 
	var g_prayersTime_temp = prayTime.getPrayerTimes(now, lat, lon);
	j=0;
	for(k=0; k<g_prayersTime_temp.length;k++){
		_DEBUG("Time "+k+" : " + g_prayersTime[k]);
		// Skip Sunrise
		if(k!=4) g_prayersTime[j++]=g_prayersTime_temp[k];
	}
	
	prayTime.setTimeFormat(prayTime.Time24NS);
	g_prayersTime24Hrs_temp = prayTime.getPrayerTimes(now, lat, lon);
	j=0;
	for(k=0; k<g_prayersTime_temp.length;k++){
		_DEBUG("Time "+k+" : " + g_prayersTime[k]);
		// Skip Sunrise
		if(k!=4) g_prayersTime24Hrs[j++]=g_prayersTime24Hrs_temp[k];
	}
	
	var k = 0;
	document.getElementById("prayertimes").style.display = ''; // Show the prayertimes table.
	document.getElementById("msg").style.display = 'none'; // Hide error message
	document.getElementById("mainPage").style.display = '';
	
	for(var i=0;i<g_prayersTime.length;i++){
    		_DEBUG(prayTime.timeNames[i] + ' : ' + g_prayersTime[i]);
		//	if(i != 4) 
		document.getElementById( ("prayer"+k++) ).innerHTML = g_prayersTime[i];
   	}
   	
	document.getElementById("location").innerHTML = System.Gadget.Settings.readString("LocationName");

	setHijriDate();
	setQibla(findQiblah(lat, lon));
			
	if(toggleTimer) clearTimeout(toggleTimer);
	toggleTimer = setTimeout("startToggling()", 10*1000);
	
	doPeriodicCheck();

	if(prayerTimesTimer) clearTimeout(prayerTimesTimer);
	prayerTimesTimer = setTimeout("RefreshPrayerTimes()", 1000*60*60*2); // Refresh times every 2 hour
}




// Reads the new zipcode from the sittings page and triggers RefreshPrayerTimes()
System.Gadget.onSettingsClosed = function (event) {
	if (event.closeAction == event.Action.commit){
		loadStrings(); // In case the selected UI language has changed.
		displayMessage("<br>"+L_REFRESH_MSG);
		RefreshPrayerTimes();
	}
	
	checkLatestVersion();
}

//Checks for the latest version, displays the appropriate message if there is one, and return ture if new version is avialable.
function checkLatestVersion(){
	//url = "http://www.techypmp.com/PrayerTimes/getLatestVersion3.php5?rnd=" + Math.random();
	url = "http://islamicalerts.com/Documents/latest_version.txt?rnd=" + Math.random();;
	try{
		var xmlHttpLocal = new XMLHttpRequest;
		xmlHttpLocal.open("GET", url, false);
		xmlHttpLocal.send();
		
		var delay = 10000;
		_DEBUG("checkLatestVersion: Waiting... Remaing count = " + delay);
		while(delay-- && xmlHttpLocal.readyState != 4) _DEBUG("checkLatestVersion: Waiting... Remaing count = " + delay);
		
		var result = xmlHttpLocal.responseText;
		_DEBUG("checkLatestVersion: " + result);
		
		versionInfo = result.split("|");
		upgradeRequired = (versionInfo[1] == "M");
		upgradeURL = "http://gallery.live.com/liveItemDetail.aspx?li=e0f661db-04f7-498a-9b37-2446dffeba01"; //versionInfo[2];
		serverURL = versionInfo[3]; 
		System.Gadget.Settings.writeString("ServerURL", serverURL);
		_DEBUG("Use this server: " + serverURL);
		optionalUpgradeEnabled = true; // for now, it's always true. We'll make it configurable later.
		var msg = "";
		
		if(System.Gadget.Settings.readString("SkipVersion") != versionInfo[0]){	
			if(isOldVersion(System.Gadget.version, versionInfo[0])){
				if(upgradeRequired){
					msg = "A new version is available. You must upgrade now.<br>Remember to close this gadget before you upgrade.";
				}else if(optionalUpgradeEnabled){
					msg = "A new optional version is available.<br>Remember to close this gadget before you upgrade.";
				}
				
				if(msg != ''){
					if(upgradeURL != ''){
						msg += "<br><a style=\"color:#66ccff;;text-decoration:none\" target=\"_blank\" href=\""+upgradeURL+"\">Download it now!</a>";	
					}
					
					if(!upgradeRequired){
							msg += "or <span onclick=\"skipVersion('"+ versionInfo[0] +"');\" style=\"color:#66ccff;cursor:hand;text-decoration:none\" href=\"#\">skip this one!</span>";
					}
					displayMessage ("<center>"+msg+"</center>");
				}
			
			}
		}
	}catch(ex){
		_DEBUG(ex.description);
		reportError(cleanFuncName(arguments.callee.toString()), ex);
	}
	
	if(versionCheckTime) clearTimeout(versionCheckTime);
	versionCheckTime = setTimeout("checkLatestVersion()", 1000*60*60*24*3); // Check every 3 days
	return null;
}

function skipVersion(v){
	System.Gadget.Settings.writeString("SkipVersion", v);
	RefreshPrayerTimes();
}

// Returns true if currentV < latestV
// Parameters are in x.x.x.x format
function isOldVersion(currentV, latestV){
	vv1 = currentV.split(".");
	vv2 = latestV.split(".");
	if(vv1.length != vv2.length && vv1.length != 4) return false;
	var vvv1 = 1000000 * parseInt(vv1[0]) + 10000 * parseInt(vv1[1]) + 100 * parseInt(vv1[2]) + 1 * parseInt(vv1[3]);
	var vvv2 = 1000000 * parseInt(vv2[0]) + 10000 * parseInt(vv2[1]) + 100 * parseInt(vv2[2]) + 1 * parseInt(vv2[3]);
	if(vvv2 > vvv1){
			_DEBUG("isOldVersion: true ... currV=" + currentV + "    latestV=" + latestV);
			return true;
	}
	_DEBUG("isOldVersion: false ... currV=" + currentV + "    latestV=" + latestV);
	return false;
}


function displayMessage(msg){
	clearTimeout(toggleTimer);
	document.getElementById("mainPage").style.display = 'none'; // Hide the prayertimes table.
	document.getElementById("page2").style.display = 'none'; // Hide the second page.
	document.getElementById("msg").style.display = '';
	document.getElementById("msg").innerHTML = msg;
	_DEBUG("displayMessage: " + msg)
}

function toggleMsg(){
	document.getElementById("msg").style.display = 'none';
	document.getElementById("page2").style.display = 'none'; // Hide the second page
	document.getElementById("mainPage").style.display = ''; // Hide the prayertimes table.
	setTimeout("showAlarm=true;", 1000*60*2);
	startToggling();
}

// Checks periodically to emphasize the next prayer and to play Azan when due.
function doPeriodicCheck(){
	try{
		_DEBUG("doPeriodicCheck");
		nextPrayerIndex = getNextPrayerIndex();
		_DEBUG("nextPrayerIndex = " + nextPrayerIndex);
		
		emphasizePrayer(nextPrayerIndex);
		
		updateRemainingTime();
		
		
		var now = new Date(); now.setSeconds(0); now.setMilliseconds(0); 
		nextPrayerTime = makeTime(g_prayersTime24Hrs[nextPrayerIndex]); 
		if(nextPrayerTime){
			if (nextPrayerTime.toTimeString() == now.toTimeString() && isAzanAlarmOk()){
				//Play Azan for nextPrayerIndex, which is the current prayer time.
				playAzan(nextPrayerIndex);
			}

			// Check Alarms
			var timeBefore = System.Gadget.Settings.readString("Prayer"+nextPrayerIndex+"_Before_Alarm");
			if(timeBefore != -1 && nextPrayerIndex != 1 && showAlarm){
				var d = new Date(nextPrayerTime.valueOf()-(timeBefore*60*1000));
				if(d.toTimeString() == now.toTimeString() && isAzanAlarmOk()){
					showAlarm = false;
					displayMessage("<b>"+L_ALARM_BEFORE_TITLE+"</b><br>"+formatStringWithParams(L_ALARM_BEFORE_BODY, Array(prayerNames[nextPrayerIndex]))+"<br><br><center><input type=\"button\" class=\"button\" value=\" "+L_OK+" \" onclick=\"javascript:toggleMsg();\"></center>");
					//System.Shell.execute("sidebar.exe"); // brings the sidebar to front
					playAlarm('before');
					setTimeout("toggleMsg()", 1000*60*2);
				}
			}

			currentPrayerIndex = nextPrayerIndex - 1;
			if(currentPrayerIndex < 0) currentPrayerIndex = 5;
			var timeAfter = System.Gadget.Settings.readString("Prayer"+currentPrayerIndex+"_After_Alarm");
			if(timeAfter != -1 && currentPrayerIndex != 1 && showAlarm){
				var pt =  makeTime(g_prayersTime24Hrs[currentPrayerIndex]); 
				var d = new Date(pt.valueOf()+(timeAfter*60*1000));
				if(d.toTimeString() == now.toTimeString()  && isAzanAlarmOk()){
					showAlarm = false;
					displayMessage("<b>"+L_ALARM_AFTER_TITLE+"</b><br>"+formatStringWithParams(L_ALARM_AFTER_BODY, Array(prayerNames[currentPrayerIndex]))+"<br><br><center><input type=\"button\" value=\" "+L_OK+" \" onclick=\"javascript:toggleMsg();\"></center>");
					//System.Shell.execute("sidebar.exe"); //Brings the sidebar to front
					playAlarm('after');
					setTimeout("toggleMsg()", 1000*60*2);
				}
			}
		}
	
		} catch (ex){
		_DEBUG(ex.description)
	}
	
	if(periodCheckingHandling != null){
		clearTimeout(periodCheckingHandling);
	}
	periodCheckingHandling = setTimeout("doPeriodicCheck()", 1000*10); // check every 10 sec.
}

function updateRemainingTime(){
	_DEBUG("updateRemainingTime");
	now = new Date(); now.setSeconds(0); now.setMilliseconds(0);
	var p1
	var p2;
	try{
		currentPrayerIndex = nextPrayerIndex - 1;
		// fix the Isha time
		if(currentPrayerIndex < 0) currentPrayerIndex = 5;
		//currentPrayerTime = getPrayerAsDate(currentPrayerIndex);
		currentPrayerTime = makeTime(g_prayersTime24Hrs[currentPrayerIndex]);
		nextPrayerTime = makeTime(g_prayersTime24Hrs[nextPrayerIndex]);
		
		_DEBUG("updateRemainingTime: currentPrayerTime = " + currentPrayerTime);
		_DEBUG("updateRemainingTime: nextPrayerTime = " + nextPrayerTime);
		
		p1 = currentPrayerTime; p1.setDate(now.getDate());
		//p2 = nextPrayerTime; p2.setDate(now.getDate());
		p2 = nextPrayerTime; p2.setDate(now.getDate());
		_DEBUG("updateRemainingTime: p1 = " + p1);
		_DEBUG("updateRemainingTime: p2 = " + p2);
		if(nextPrayerIndex == 0){
			_DEBUG("updateRemainingTime: now.getHours() = " + now.getHours());
			if(now.getHours() > 12){ // If the next prayer is Fajer and time is afternoon (night) then this the Fajr of the next day.
				p2 = new Date(now.getYear(), now.getMonth(), now.getDate() + 1, nextPrayerTime.getHours(), nextPrayerTime.getMinutes(), 0);

			}else{
				p1 = new Date(now.getYear(), now.getMonth(), now.getDate() - 1, nextPrayerTime.getHours(), nextPrayerTime.getMinutes(), 0);
			}
		}
		_DEBUG("updateRemainingTime: p2 = " + p2);
		var d = Math.abs(p2.valueOf() - now.valueOf());
		_DEBUG("updateRemainingTime: d=" + d);
		rh = Math.floor(d/(1000*60*60)) % 24; 
		//_DEBUG("updateRemainingTime: rh=" + rh);
		rm = Math.ceil((d-(rh*1000*60*60))/(1000*60)) % 60;
		if(rh < 10) {rh = "0"+rh;}
		if(rm < 10) {rm = "0"+rm;}

		//_DEBUG("updateRemainingTime: p1=" + p1);
		//_DEBUG("updateRemainingTime: p2=" + p2);
		currentProgress = interpolateIndex(0, 99, p1, p2);
		_DEBUG("updateRemainingTime: currentProgress=" + currentProgress);
		currentIndex = Math.floor(currentProgress * remainingTimeColors.length / 100);
		_DEBUG("updateRemainingTime: currentIndex=" + currentIndex);
		currentWaitTimeIndex = Math.floor(currentProgress * waitTimes.length / 100);
		progressBar.style.height = Math.floor(currentProgress * 97 / 100);
		progressBar.style.backgroundColor = remainingTimeColors[currentIndex];
		document.getElementById("timeRemaining").innerHTML = rh + ":" + rm;
		document.getElementById("timeRemaining").style.color = remainingTimeColors[currentIndex];
		document.getElementById("remaingTimePrayer").innerText = formatStringWithParams(L_TIME_TILL_TITLE, Array(prayerNames[nextPrayerIndex]));
	} catch (ex){
		_DEBUG(ex.description);
		reportError(cleanFuncName(arguments.callee.toString()), ex);
	}
}

function interpolateIndex(minIndex, maxIndex, currentTime, nextTime){
	try{
		var now = new Date();
		//_DEBUG("interpolareIndex: currentTime = " + currentTime + " >> " + currentTime.valueOf());
		//_DEBUG("interpolareIndex: now = " + now + " >> " + now.valueOf());
		//_DEBUG("interpolareIndex: nextTime = " + nextTime + " >> " + nextTime.valueOf());
		var a = (nextTime.valueOf()-now.valueOf()); 
		//_DEBUG("interpolareIndex: a = " + a);
		var b = (maxIndex-minIndex);
		//_DEBUG("interpolareIndex: b = " + b);
		var c = (nextTime.valueOf()-currentTime.valueOf());
		//_DEBUG("interpolareIndex: c = " + c);
		var d = Math.abs(Math.ceil(maxIndex - ( (a*b)/c )));
		//_DEBUG("interpolareIndex: d = " + d);
		if(d < minIndex) d = minIndex;
		if(d > maxIndex) d = maxIndex;
		return d;
	}catch(ex){
		_DEBUG(ex.description);
		reportError(cleanFuncName(arguments.callee.toString()), ex);
	}
}

function emphasizePrayer(prayerIndex){
	try{
		_DEBUG("emphasizePrayer: " + prayerIndex);
		document.getElementById( ("prayer"+prayerIndex) ).parentElement.style.color='#66ccff';
		document.getElementById( ("prayer"+prayerIndex) ).parentElement.style.fontWeight='bold';
		if(g_lastEmphasized >=0 && g_lastEmphasized != prayerIndex){
			document.getElementById( ("prayer"+g_lastEmphasized) ).parentElement.style.color='white';
			document.getElementById( ("prayer"+g_lastEmphasized) ).parentElement.style.fontWeight='normal';
		}
		g_lastEmphasized = prayerIndex;
	}catch(ex){
		_DEBUG(ex.description);
		reportError(cleanFuncName(arguments.callee.toString()), ex);
	}
}

function playAlarm(alarmType){
	_DEBUG("playAlarm");
	try{
		if(System.Gadget.Settings.readString("AlarmsEnbled") == "True"){
			// alarmType can be 'after' or 'before' the currnetPrayerIndex
			var alarmFile = getAlarmFile();//serverURL+"getAlarm.php5";
			_DEBUG("playAlarm: " + alarmFile);
			if(currentPrayerIndex == 0 && System.Gadget.Settings.readString("Morning_Azkar_Enabled") == "True" && alarmType == 'after'){
				alarmFile = serverURL+"getMedia2.php5?file=morningazkar";
			}else if(currentPrayerIndex == 3 && System.Gadget.Settings.readString("Evening_Azkar_Enabled") == "True" && alarmType == 'after'){
				alarmFile = serverURL+"getMedia2.php5?file=eveningazkar";
			} 
		
			playSoundFile(alarmFile, "65");
		}
	}catch(ex){
		_DEBUG(ex.description);
		reportError(cleanFuncName(arguments.callee.toString()), ex);
	}
}

function playAzan(prayerIndex){
	var availableAzans = new Array("bahrain", "brunei", "jordan", "hayatfm", "egypt", "kuwait", "madina", "malasyia", "mecca", "qods", "sudan","tunisia","turkey","surprise");
	try{
		if(prayerIndex == 0) FajrNextDay = false;
		if(prayerIndex != 1 && lastAzanPlayed != prayerIndex){ // Not Sunrise and not played before.
			if(System.Gadget.Settings.readString("Prayer"+prayerIndex+"_Azan_Enabled") == "True"){
				var azanFile = System.Gadget.Settings.readString("AzanFile");
				if(prayerIndex == 0) azanFile = System.Gadget.Settings.readString("FajrAzanFile");
				
				// If Azan is random
				if(System.Gadget.Settings.readString("AzanOption") == "random"){
					var i = Math.floor(Math.random( ) * 1000) % availableAzans.length; //pick a random index
					if(i>=availableAzans.length) i = availableAzans.length-1; // make sure that it's within the limit
					var azanFile = serverURL+'getMedia2.php5?file=' + availableAzans[i]; // Select the random azan
					if(prayerIndex == 0) azanFile = azanFile + 'fajr'; // fix it for Fajr
				}
				
				var vol = System.Gadget.Settings.readString("AzanVolume");
				lastAzanPlayed = prayerIndex;
				playSoundFile(azanFile, vol);
				
				
			}
		}
	}catch(ex){
		_DEBUG(ex.description);
		reportError(cleanFuncName(arguments.callee.toString()), ex);
	}
}

function playSoundFile(f, vol){
	try{
		if (player){
			_DEBUG("Play:" + f);
			player.settings.volume = vol;
			player.URL = f;
			player.controls.play();
			document.getElementById('stopSoundButton').style.display = '';
			
			setTimeout('checkPlayerState()', 200);
				
			//stopSoundButton.filters.item("DXImageTransform.Microsoft.Alpha").opacity = 40;
			//stopSoundButton.style.display = '';
		}
	}catch(ex){
		_DEBUG(ex.description);
		reportError(cleanFuncName(arguments.callee.toString()), ex);
	}
}


function checkPlayerState(){
	_DEBUG("state = " + player.PlayState );
	if(player.PlayState != 3){
		document.getElementById('stopSoundButton').style.display = 'none';
	}else{
		setTimeout('checkPlayerState()', 200);
	}
}

function getNextPrayerIndex_old(){
	try{
		var now = new Date(); now.setSeconds(0); now.setMilliseconds(0);
		if(g_prayersTime != null){
			for(i=0;i<g_prayersTime.length;i++){
				prayerTime = getPrayerAsDate(i);
				if(now.valueOf() <= prayerTime.valueOf()) {
					nextPrayerIndex = i ;
					break;
				}
			}
			if(i == g_prayersTime.length){ // we passed Isha 
				nextPrayerIndex = 0;
			}
	
			return nextPrayerIndex;
		} 
	}catch(ex){
		_DEBUG(ex.description); reportError(cleanFuncName(arguments.callee.toString()), ex);
	}
}

function getNextPrayerIndex(){
	try{
		_DEBUG("getNextPrayerIndex");		
		var nextPrayerIndex = -1;
		var now = new Date(); now.setSeconds(0); now.setMilliseconds(0);
		if(g_prayersTime24Hrs != null){
			for(i=0;i<g_prayersTime24Hrs.length;i++){
				prayerTime = makeTime(g_prayersTime24Hrs[i]);
//				_DEBUG("getNextPrayerIndex: " + prayerTime + " === " + now);
				if(now.valueOf() <= prayerTime.valueOf()) {
					nextPrayerIndex = i ;
					break;
				}
			}

			if(nextPrayerIndex == 6){ // If Isha 
				nextPrayerIndex = 5; // Then skip adjust the index mapping. We ignore Sunsit
			}
			
			g_PassedIsha = false;
			
			if(nextPrayerIndex == -1){ // we passed Isha 
				g_PaasedIsha = true;
				nextPrayerIndex = 0;
			}
			//_DEBUG("getNextPrayerIndex:"+nextPrayerIndex); 
			return nextPrayerIndex;
		} 
	}catch(ex){
		_DEBUG(ex.description); reportError(cleanFuncName(arguments.callee.toString()), ex);
	}
}


function getPrayerAsDate(prayerIndex){
	try{
		if(g_prayersTime!= null){
			var hhmm = g_prayersTime[prayerIndex].split(":");
		
			if(prayerIndex > 2){ // Asr, Maghrib and Isha
				hhmm[0] = parseInt(hhmm[0]) + 12; // convert to 24hrs
			}else {
				if(prayerIndex == 2){ // Duhr
					if(hhmm[0] < 5) {
						hhmm[0] = parseInt(hhmm[0]) + 12; // convert to 24hrs
					}
				}
			}
	
			var now = new Date();
			var prayerTime = new Date(now.getYear(), now.getMonth(), now.getDate(), hhmm[0], hhmm[1], 0);
	
			return prayerTime;
		}
	}catch(ex){
		_DEBUG(ex.description); reportError(cleanFuncName(arguments.callee.toString()), ex);
	}
}

function getPrayerAsDate2(prayersArray, prayerIndex){
	try{
		if(prayersArray!= null){
			var hhmm = prayersArray[prayerIndex].split(":");
		
			if(prayerIndex > 2){ // Asr, Maghrib and Isha
				hhmm[0] = (parseInt(hhmm[0]) + 12) % 24; // convert to 24hrs
			}else {
				if(prayerIndex == 2){ // Duhr
					if(hhmm[0] < 5) {
						hhmm[0] = (parseInt(hhmm[0]) + 12) % 24; // convert to 24hrs
					}
				}
			}
			_DEBUG("getPrayerAsDate2: " + hhmm[0] + ":" + hhmm[1]);
			var now = new Date();
			var prayerTime = new Date(now.getYear(), now.getMonth(), now.getDate(), hhmm[0], hhmm[1], 0);
	
			return prayerTime;
		}
	}catch(ex){
		_DEBUG(ex.description); reportError(cleanFuncName(arguments.callee.toString()), ex);
	}
}

function makeTime(vPrayerTime){
	_DEBUG("makeTime: " + vPrayerTime);
	
	try{
		if(vPrayerTime!= null){
			var hhmm = vPrayerTime.split(":");

			var now = new Date();
			var prayerTime = new Date(now.getYear(), now.getMonth(), now.getDate(), hhmm[0], hhmm[1], 0);
	
			return prayerTime;
		}
	}catch(ex){
		_DEBUG(ex.description); reportError(cleanFuncName(arguments.callee.toString()), ex);
	}
}


function stopSound(){
	try{
		if(player){
			player.controls.stop();
			document.getElementById('stopSoundButton').style.display = 'none';
		}
		//stopSoundButton.style.display = 'none';
	}catch(ex){
		_DEBUG(ex.description); reportError(cleanFuncName(arguments.callee.toString()), ex);
	}		
}

function setHijriDate(){
	try{
		var months = Array(L_MUHARRAM, L_SAFAR, L_RABI1, L_RABI2, L_JUMADA1, L_JUMADA2, L_RAJAB, L_SHABAN, L_RAMADAN, L_SAWAL, L_ZULQIDAH, L_ZULHIJJAH); 

  	    var dt = TodayHijriDate();
		d = dt.date;
		m = dt.month;
		y = dt.year;
		document.getElementById( "hijriDate" ).innerHTML = d + "-" + months[m-1] + "-" + y;
	}catch(ex){
		_DEBUG(ex.description); reportError(cleanFuncName(arguments.callee.toString()), ex);
	}	
}

function setQibla(q){
	try{
		document.getElementById( "qiblaAngle" ).innerHTML = formatStringWithParams(L_QIBLA_ANGLE_MSG, Array( "" + (Math.round(q*10)/10) ));
	}catch(ex){
		_DEBUG(ex.description); reportError(cleanFuncName(arguments.callee.toString()), ex);
	}
}

var opTimer = null;

function increaseOpacity(){
	try{
		clearTimeout(opTimer);
		if(parseInt(stopSoundButton.filters.item("DXImageTransform.Microsoft.Alpha").opacity) < 100){
			_DEBUG("increaseOpacity: " + stopSoundButton.filters.item("DXImageTransform.Microsoft.Alpha").opacity);
			stopSoundButton.filters.item("DXImageTransform.Microsoft.Alpha").opacity += 5;
			opTimer = setTimeout("increaseOpacity()", 100);
		}else{
			clearTimeout(opTimer);
			_DEBUG("increasOpacity: Timer cleared");
		}
	}catch(ex){
		_DEBUG(ex.description); reportError(cleanFuncName(arguments.callee.toString()), ex);
	}
}

function decreaseOpacity(){
	try{
		clearTimeout(opTimer);
		if(parseInt(stopSoundButton.filters.item("DXImageTransform.Microsoft.Alpha").opacity) >= 50){
			_DEBUG("decreaseOpacity: " + stopSoundButton.filters.item("DXImageTransform.Microsoft.Alpha").opacity);
			stopSoundButton.filters.item("DXImageTransform.Microsoft.Alpha").opacity -= 5;
			opTimer = setTimeout("decreaseOpacity()", 100);
		}else{
			clearTimeout(opTimer);
			_DEBUG("decreaseOpacity: Timer cleared");
		}
	}catch(ex){
		_DEBUG(ex.description); reportError(cleanFuncName(arguments.callee.toString()), ex);
	}
}


function isAzanAlarmOk(){
	if(System.Gadget.Settings.readString("allowAAPPT") == "False"){
		_DEBUG("Disable Azan and Alarms when PowerPoint is running");
		var e = new Enumerator( GetObject( "winmgmts:" ).InstancesOf( "Win32_process" ) );
		for (;!e.atEnd();e.moveNext()){    
			var p = e.item ();     
			if(p.Name.toUpperCase() == "POWERPNT.EXE"){
				_DEBUG("Found PowerPoint running in memory!");
				return false;
			}
		}
	}
	return true;
}

function convertPrayersToTimes(pp){
	var pTime = new Array();
	var add12 = 0;
	var addDay = 0;
	var previousHour = 0;
	var now = new Date();
	var i;
	//_DEBUG("convertPrayersToTimes: " + pp);
	try{
		for(i=0;i<6;i++){
			var hhmm = pp[i].split(":");
			var hh = parseInt(hhmm[0]);
			if(hh < previousHour) { 
				add12++; 
				//_DEBUG("convertPrayersToTimes: hh=" +hh+ " prev=" +previousHour+" >>>add12=" + add12);
			}
			hhmm[0] = hh + (12 * add12);
			//_DEBUG(" Hour= " + hhmm[0]);
			previousHour = hh;
			if(hhmm[0] >= 24) {
				addDay = 1;
			}
			var prayerTime = new Date(now.getYear(), now.getMonth(), now.getDate(), parseInt(hhmm[0]), parseInt(hhmm[1]), 0);
			_DEBUG("convertPrayersToTimes("+i+") : " + prayerTime + " ( " + prayerTime.valueOf() +" )");
			pTime[i] = prayerTime;
		}

		return pTime;
	}catch(ex){
		_DEBUG("convertPrayersToTimes: " + ex.Description);
		reportError(cleanFuncName(arguments.callee.toString()), ex);
	}
}




function TodayHijriDate() {
	var now = new Date();
	var adjustedDate = new Date(now.getYear(), now.getMonth(), now.getDate()+parseInt(System.Gadget.Settings.readString("HijriAdjustment")),now.getHours(),now.getMinutes(),now.getSeconds(),0);
	_DEBUG("TodayHijriDate: adjustedDate = " + adjustedDate + " === " + now + " TZ=" + now.getTimezoneOffset()/60);
	var d=adjustedDate.getDate();
	var m=adjustedDate.getMonth();
	var y=adjustedDate.getYear();
	var delta=1, jd, l, n, j, m, d, y;

	if ((y>1582)||((y==1582)&&(m>10))||((y==1582)&&(m==10)&&(d>14))){
		//added +delta on jd to comply isna rulling
		jd=intPart((1461*(y+4800+intPart((m-14)/12)))/4)+intPart((367*(m-2-12*(intPart((m-14)/12))))/12)-intPart((3*(intPart((y+4900+intPart((m-14)/12))/100)))/4)+d-32075+delta;
	}else{
		//added +delta on jd to comply isna rulling
		jd = 367*y-intPart((7*(y+5001+intPart((m-9)/7)))/4)+intPart((275*m)/9)+d+1729777+delta;
	}

	l=jd-1948440+10632;
	n=intPart((l-1)/10631);
	l=l-10631*n+354;
	j=(intPart((10985-l)/5316))*(intPart((50*l)/17719))+(intPart(l/5670))*(intPart((43*l)/15238));
	l=l-(intPart((30-j)/15))*(intPart((17719*j)/50))-(intPart(j/16))*(intPart((15238*j)/43))+29;
	m=intPart((24*l)/709); 
	d=l-intPart((709*m)/24);
	y=30*n+j-30+intPart(m/12);
	
	m = (m%12) + 1; // +1 to shift the 0-based number
	
	_DEBUG("TodayHijriDate: " + d + "-" + m + "-" + y);
	
	return {date : d, month : m, year: y};
}


function findQiblah(vLat, vLon) {
	var meccaLat =  21.42252 * (Math.PI / 180.0); //Make them Radians
	var meccaLong = 39.82608 * (Math.PI / 180.0);
	var latitude = vLat * (Math.PI / 180.0);
	var longitude = vLon  * (Math.PI / 180.0);
	
    var y = Math.sin(Math.abs(meccaLong-longitude)) * Math.cos(meccaLat);
    var x = Math.cos(latitude) * Math.sin(meccaLat) - Math.sin(latitude) * Math.cos(meccaLat)*Math.cos(Math.abs(meccaLong-longitude));

    var z = (Math.atan2(y, x) * 180.0 / Math.PI); // Make it Degrees
	
	_DEBUG("findQiblah = " + z);
	
	return z;
}


